/*
 *    Copyright (c) 2018-2025, lengleng All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the yifu4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: lengleng (wangiegie@gmail.com)
 */

package com.yifu.cloud.plus.v1.yifu.archives.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmployeeContractInfo;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmployeeContractPre;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmployeeContractPreNew;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yifu.cloud.plus.v1.yifu.archives.vo.*;
import com.yifu.cloud.plus.v1.yifu.common.core.util.ErrorMessage;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;

import javax.servlet.http.HttpServletResponse;
import java.io.InputStream;
import java.time.LocalDate;
import java.util.Date;
import java.util.List;

/**
 * 合同续签预派单信息
 *
 * @author fxj
 * @date 2026-02-05 15:45:40
 */
public interface TEmployeeContractPreNewService extends IService<TEmployeeContractPreNew> {
	/**
	 * 合同续签预派单信息简单分页查询
	 *
	 * @param tEmployeeContractPreNew 合同续签预派单信息
	 * @return
	 */
	IPage<TEmployeeContractPreNew> getTEmployeeContractPreNewPage(Page<TEmployeeContractPreNew> page, TEmployeeContractPreNewSearchVo tEmployeeContractPreNew);

	void listExport(HttpServletResponse response, TEmployeeContractPreNewSearchVo searchVo);

	List<TEmployeeContractPreNew> noPageDiy(TEmployeeContractPreNewSearchVo searchVo);

	R confirmRenewalContract(TEmployeeContractPreNewVo preVo);

	R batchCconfirmRenewalContract(TEmployeeContractPreNewVo preVo);

	R dispatcherContract(List<String> idList, String type);

	R revokeSign(List<TEmployeeAutoRegistRevokeVo> registRevokeVoList);

	R autoRevokeElectronicSign();

	R notifyRevokedElectronicSign();

	R electronicSignExpiringReminder();

	R contractUrg(String id);

	R<TEmployeeContractPreNew> getInfoByPreId(String preId);

	R<List<TEmployeeContractPreNewDetailVo>> getDetailList(ContractAlertSearchVo tEmployeeContractPreNew);

	R<TEmployeeContractInfo> getRenewContractByPreId(String preId);

	R pushWxConfrimMessage();

	void pushDisConfrimContracts();

	R<Integer> getDetailListCount(ContractAlertSearchVo tEmployeeContractPreNew);

	R getContractTerm(String startDate, String endDate);

	LocalDate getPreDateByConfigId(String configId, Date contractEnd);

	void updateByIdAndUpdateAlert(TEmployeeContractPreNew preNew);
}
